/*
 * ProcessLifetime class.
 *
 * Copyright (C) 2007 SATOH Takayuki All Rights Reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package ts.util.lifetime;

/**
 * プロセスの終了に合わせて生存期間を決定する{@link ts.util.lifetime.Lifetime
 * Lifetime}クラス。
 * <br>
 * 指定されたプロセスの終了を検知して、格納している{@link ts.util.lifetime.Life
 * Life}オブジェクトの{@link ts.util.lifetime.Life#willDie() willDie()}メソッド
 * を呼び出す。
 *
 * @author  佐藤隆之.
 * @version $Revision: 1.1.1.1 $, $Date: 2010-10-16 00:03:48 $
 */
public class ProcessLifetime extends Lifetime
{
  /**
   * デフォルト・コンストラクタ。  
   */
  public ProcessLifetime()
  {}

  /**
   * 生存期間を決定する{@link java.lang.Process Process}オブジェクトを設定する。
   *
   * @param  process 生存期間を決定する{@link java.lang.Process Process}
   *           オブジェクト。
   * @throws AssertionError 引数がヌルの場合（デバッグ・モードのみ）。
   */
  public void setLifeLong(final Process process)
  {
    assert (process != null) : "@param:process is null.";

    Thread notifyThread = new Thread() {
      public void run() {
        try {
          process.waitFor();
          processEnded(process);
        }
        catch (Exception e) {
          catchProcessException(e, process);
        }
        finally {
          kill();
        }
      }
    };
    notifyThread.start();
  }

  /**
   * プロセスの終了時に呼ばれるメソッド。
   * <br>
   * プロセスの終了コードを調べるなど、プロセスの終了時に何からの処理を行いたい
   * 場合は、このメソッドをオーバーライドする。
   * <br>
   * このクラスでは、何もしない。
   *
   * @param  process プロセス・オブジェクト。
   */
  protected void processEnded(Process process)
  {}

  /**
   * プロセスの終了を待っている間に例外が発生した場合に、その例外を受け付ける。
   * <br>
   * 例外が発生時に何らかの処理を行いたい場合には、このメソッドをオーバーライド
   * する。
   * <br>
   * このクラスでは、何もしない。
   * 
   * @param  exc 発生した例外。
   * @param  process プロセス・オブジェクト。
   */
  protected void catchProcessException(Exception exc, Process process)
  {}
}

